> ## Documentation Index
> Fetch the complete documentation index at: https://docs.shipstream.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Get one User

> Returns a single `User` object specified by its `type` and `id` path parameters.



## OpenAPI

````yaml GET /v1/system/users/{type}/{id}
openapi: 3.0.3
info:
  title: ShipStream
  version: '1.0'
  license:
    name: Commercial (Copyright 2025 - All Rights Reserved)
    url: https://shipstream.io
  contact:
    name: ShipStream Support
    email: help@shipstream.io
  termsOfService: https://shipstream.io/legal/api-terms/
servers:
  - url: https://{base_url_domain}/api/global
    description: Direct API Url
    variables:
      base_url_domain:
        default: example.shipstream.app
        description: >-
          The fully qualified domain name for your ShipStream WMS instance. This
          is either a custom domain, or a subdomain of shipstream.app,

          and will be the same as the domain name for the page which you use to
          login to ShipStream WMS.
security:
  - ShipStream_bearerAuth: []
tags:
  - name: Warehouses
    x-displayName: Warehouses
  - name: Products
    x-displayName: Products
  - name: Locations
    x-displayName: Locations
  - name: Levels
    x-displayName: Levels
  - name: HoldReasons
    x-displayName: HoldReasons
  - name: Holds
    x-displayName: Holds
  - name: Deliveries
    description: Every thing about a Delivery Receiving
    x-displayName: Deliveries
  - name: Shipments
    x-displayName: Shipments
  - name: Orders
    x-displayName: Orders
  - name: Retailers
    x-displayName: Retailers
  - name: Users
    x-displayName: Users
  - name: User Roles
    x-displayName: User Roles
  - name: Merchants
    x-displayName: Merchants
  - name: Healthcheck
    x-displayName: Healthcheck
paths:
  /v1/system/users/{type}/{id}:
    get:
      tags:
        - Users
      summary: Get one User
      description: >-
        Returns a single `User` object specified by its `type` and `id` path
        parameters.
      operationId: getUser
      parameters:
        - $ref: '#/components/parameters/System_API_v1_user-type'
        - $ref: '#/components/parameters/System_API_v1_user-fields'
        - $ref: '#/components/parameters/System_API_v1_fields-roles'
        - $ref: '#/components/parameters/System_API_v1_fields-warehouse'
        - in: path
          name: id
          schema:
            type: integer
            format: int32
            minimum: 1
          required: true
          description: The `id` of the referenced `User`.
        - $ref: '#/components/parameters/System_API_v1_fields-merchant'
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                type: object
                properties:
                  resource:
                    $ref: '#/components/schemas/System_API_v1_CompositeUser'
                  included:
                    $ref: '#/components/schemas/System_API_v1_users'
        '400':
          $ref: '#/components/responses/System_API_v1_400-bad-request'
        '404':
          $ref: '#/components/responses/System_API_v1_404-not-found'
        '500':
          $ref: '#/components/responses/System_API_v1_500-internal-server-error'
components:
  parameters:
    System_API_v1_user-type:
      name: type
      in: path
      required: true
      description: Specify the user type to which your operations will be restricted.
      schema:
        type: string
        enum:
          - any
          - organization
          - client
    System_API_v1_user-fields:
      name: fields
      in: query
      required: false
      description: >-
        Specify additional fields of the `OrganizationUser` or `ClientUser`
        objects to be included in the response.

        See the [selecting fields](/global-api/selecting-fields) page for more
        information.
      explode: false
      schema:
        $ref: '#/components/schemas/System_API_v1_user-fields-enum'
    System_API_v1_fields-roles:
      name: fields:roles
      in: query
      required: false
      description: >-
        Specify additional fields of the `OrganizationRole` or `ClientRole`
        object to be included in the response. See the [selecting
        fields](/global-api/selecting-fields) page for more information.
      explode: false
      schema:
        type: array
        items:
          type: string
          enum:
            - all
    System_API_v1_fields-warehouse:
      name: fields:warehouse
      in: query
      required: false
      description: >-
        Specify additional fields of the `Warehouse` object to be included in
        the response. See the [selecting fields](/global-api/selecting-fields)
        page for more information.
      explode: false
      schema:
        $ref: '#/components/schemas/System_API_v1_warehouse-fields-enum'
    System_API_v1_fields-merchant:
      name: fields:merchant
      in: query
      required: false
      description: >-
        Specify additional fields of the `Merchant` object to be included in the
        response. See the [selecting fields](/global-api/selecting-fields) page
        for more information.
      explode: false
      schema:
        $ref: '#/components/schemas/System_API_v1_merchant-fields-enum'
  schemas:
    System_API_v1_CompositeUser:
      type: object
      anyOf:
        - $ref: '#/components/schemas/System_API_v1_OrganizationUser'
        - $ref: '#/components/schemas/System_API_v1_ClientUser'
      discriminator:
        propertyName: type
    System_API_v1_users:
      type: object
      description: >-
        Lists of referenced objects included by specifying optional fields.

        See the [selecting fields](/global-api/selecting-fields) page for more
        information.
      properties:
        ClientUserRole:
          type: array
          items:
            $ref: '#/components/schemas/System_API_v1_ClientUserRole'
        Merchant:
          type: array
          items:
            $ref: '#/components/schemas/System_API_v1_Merchant'
        OrganizationUserRole:
          type: array
          items:
            $ref: '#/components/schemas/System_API_v1_OrganizationUserRole'
        Warehouse:
          type: array
          items:
            $ref: '#/components/schemas/System_API_v1_Warehouse'
    System_API_v1_user-fields-enum:
      type: array
      items:
        type: string
        enum:
          - basic
          - all
          - created_at
          - updated_at
          - last_login_at
          - login_via_badge
          - is_deleted
          - roles
          - default_warehouse
    System_API_v1_warehouse-fields-enum:
      title: Warehouse
      description: >-
        Specify additional fields of the `Warehouse` object to be included in
        the response.
      type: array
      items:
        type: string
        enum:
          - basic
          - all
          - id
          - name
          - is_active
          - abbreviation
    System_API_v1_merchant-fields-enum:
      title: Merchant
      type: array
      items:
        type: string
        enum:
          - basic
          - all
          - code
          - name
          - status
          - created_at
          - updated_at
          - brands
          - default_brand
          - custom_fields
    System_API_v1_OrganizationUser:
      title: OrganizationUser
      description: A user with organization-wide access.
      allOf:
        - $ref: '#/components/schemas/System_API_v1_AbstractUser'
        - type: object
          properties:
            type:
              type: string
              enum:
                - OrganizationUser
              description: This property describes the type of object in the response body.
            login_via_badge:
              type: boolean
              example: true
              description: |-
                This flag must be `true` to allow login with badge capability.\
                  `Optional Field`
            default_warehouse:
              allOf:
                - $ref: '#/components/schemas/System_API_v1_WarehouseRef'
                - description: |-
                    The last `Warehouse` that was active for the user.\
                      `Optional Field`
    System_API_v1_ClientUser:
      title: ClientUser
      description: A user with limited access and assigned to a single merchant.
      allOf:
        - $ref: '#/components/schemas/System_API_v1_AbstractUser'
        - type: object
          properties:
            type:
              type: string
              enum:
                - ClientUser
              description: This property describes the type of object in the response body.
            merchant:
              allOf:
                - $ref: '#/components/schemas/System_API_v1_MerchantRef'
                - description: |-
                    The Merchant to which this user belongs.\
                      `Optional Field`
    System_API_v1_ClientUserRole:
      title: ClientUserRole
      description: >-
        A `ClientUserRole` is used to provide a specific set of permissions to
        an external client user.
      allOf:
        - $ref: '#/components/schemas/System_API_v1_AbstractUserRole'
        - type: object
          properties:
            type:
              type: string
              enum:
                - ClientUserRole
              description: >-
                This is a read-only property that describes the type of object
                in the response body.
    System_API_v1_Merchant:
      title: Merchant
      type: object
      description: >-
        A `Merchant` represents an entity that owns a distinct pool of inventory
        and line of business.
      properties:
        type:
          type: string
          enum:
            - Merchant
          readOnly: true
        id:
          type: integer
          format: int32
          description: >-
            The internal `id` property used as a path parameter in a resource
            lookup.
          readOnly: true
          example: 4
        code:
          type: string
          description: >-
            Merchant code may only contain letters (a-z), numbers (0-9) or
            underscore(_), the first character must be a letter.
          minLength: 1
          maxLength: 32
          example: acme_inc
        name:
          type: string
          description: Any string which uniquely identifies a Merchant.
          minLength: 1
          maxLength: 64
          example: ACME Inc.
        status:
          type: string
          enum:
            - active
            - inactive
            - suspended
            - archived
          default: active
          description: >-
            Lifecycle status of the Merchant:

            - `active`: Merchant is operational and available for use

            - `suspended`: Temporarily on hold, can be easily reactivated

            - `inactive`: Long-term offline status, reactivation is possible but
            may require additional steps

            - `archived`: Soft delete status, manual recovery required
          example: active
          nullable: true
          readOnly: true
        created_at:
          $ref: '#/components/schemas/System_API_v1_created_at-optional'
        updated_at:
          $ref: '#/components/schemas/System_API_v1_updated_at'
        brands:
          type: array
          items:
            allOf:
              - $ref: '#/components/schemas/System_API_v1_BrandRef'
          description: >-
            A merchant must have one or more brands which may share the same
            pool of inventory. Brands can be used for

            customizing presentation and behaviors and often correspond to
            distinct lines of business or market presences.\
              `Optional Field`
          readOnly: true
        default_brand:
          allOf:
            - $ref: '#/components/schemas/System_API_v1_BrandRef'
          description: >-
            This is the primary brand used when defining only the merchant for
            operations such as creating a new product.\
              `Optional Field`
        custom_fields:
          allOf:
            - $ref: '#/components/schemas/System_API_v1_sales_custom_fields'
          nullable: true
          description: >-
            Custom fields associated with the merchant in script format. Each
            field contains

            a code and value, with additional properties depending on the field
            type.\
              `Optional Field`
    System_API_v1_OrganizationUserRole:
      title: OrganizationUserRole
      description: >-
        An `OrganizationUserRole` is used to provide a specific set of
        permissions to an organization's user.
      allOf:
        - $ref: '#/components/schemas/System_API_v1_AbstractUserRole'
        - type: object
          properties:
            type:
              type: string
              enum:
                - OrganizationUserRole
              description: >-
                This is a read-only property that describes the type of object
                in the response body.
    System_API_v1_Warehouse:
      title: Warehouse
      type: object
      description: >-
        A `Warehouse` represents a physical location from which you can store
        inventory and perform operations independently of other warehouses.
      properties:
        type:
          type: string
          enum:
            - Warehouse
          readOnly: true
          description: >-
            This is a read-only property that describes the type of object in
            the response body.
        id:
          type: integer
          format: int32
          example: 3
          readOnly: true
          description: >-
            The internal `id` property used as a path parameter in a resource
            lookup.
        name:
          type: string
          example: East Coast 1
          maxLength: 255
          description: The display name for the `Warehouse`.
        abbreviation:
          type: string
          maxLength: 10
          nullable: true
          example: EC1
          description: >-
            A short abbreviation for the `Warehouse`, up to 10 characters.
            Recommended to be fewer than 6 characters.\
              `Optional Field`
        is_active:
          type: boolean
          example: true
          description: >-
            This flag determines if the `Warehouse` is active and viable for
            fulfillment.
      required:
        - type
        - id
      additionalProperties: false
    System_API_v1_AbstractUser:
      type: object
      properties:
        type:
          type: string
          enum:
            - OrganizationUser
            - ClientUser
        id:
          type: integer
          format: int32
          example: 3
          readOnly: true
          description: >-
            The internal `id` property used as a path parameter in a resource
            lookup.
        name:
          type: string
          maxLength: 65
          example: Bernard Greensmith
          description: The full name of the user.
        email:
          type: string
          maxLength: 128
          format: email
          example: admin@example.com
          description: The user's email address.
        username:
          type: string
          maxLength: 40
          example: b.greensmith
          description: User name for login.
        is_active:
          type: boolean
          example: true
          description: Only active users may log in.
        roles:
          type: array
          items:
            $ref: '#/components/schemas/System_API_v1_UserRoleRef'
          description: |-
            A list of user roles allowed for this user.\
              `Optional Field`
      required:
        - type
        - id
    System_API_v1_WarehouseRef:
      title: WarehouseRef
      type: object
      description: A reference to a `Warehouse` by `id`.
      properties:
        type:
          type: string
          enum:
            - Warehouse
          description: This property describes the type of object in the response body.
        id:
          type: integer
          format: int32
          description: >-
            The internal `id` property used as a path parameter in a resource
            lookup.
      required:
        - type
        - id
      nullable: true
      additionalProperties: false
    System_API_v1_MerchantRef:
      title: MerchantRef
      type: object
      description: Reference a `Merchant` by `id`.
      properties:
        type:
          type: string
          enum:
            - Merchant
        id:
          type: integer
          format: int32
          example: 4
          description: >-
            The internal `id` property used as a path parameter in a resource
            lookup.
      required:
        - type
        - id
      additionalProperties: false
    System_API_v1_AbstractUserRole:
      type: object
      properties:
        type:
          type: string
          enum:
            - OrganizationUserRole
            - ClientUserRole
        id:
          type: integer
          readOnly: true
          example: 3
          description: >-
            The internal `id` property used as a path parameter in a resource
            lookup.
        name:
          type: string
          maxLength: 50
          example: Administrators
          description: The name of the User Role.
        permissions:
          type: array
          description: A list of permissions for a single role.
          items:
            type: string
          example:
            - warehouse
            - warehouse/staff
            - warehouse/staff/time_entry_log
            - warehouse/staff/time_management
            - warehouse/staff/time_management/excluded
            - warehouse/staff/time_management/status_dashboard
      additionalProperties: false
    System_API_v1_created_at-optional:
      type: string
      format: date-time
      description: >-
        The date and time the object was created in RFC 3339 section 5.6
        notation.\
          `Optional Field`
      example: '2017-07-21T17:32:28Z'
      nullable: true
      readOnly: true
    System_API_v1_updated_at:
      type: string
      format: date-time
      description: >-
        The date and time the object was last updated in RFC 3339 section 5.6
        notation.\
          `Optional Field`
      example: '2017-07-21T17:39:43Z'
      nullable: true
      readOnly: true
    System_API_v1_BrandRef:
      title: BrandRef
      type: object
      description: Reference a `Brand` by `id`.
      properties:
        type:
          type: string
          enum:
            - Brand
        id:
          type: integer
          format: int32
          description: The numeric `id` of a particular resource being updated.
          example: 4
      required:
        - type
        - id
      additionalProperties: false
    System_API_v1_sales_custom_fields:
      type: object
      description: >-
        Custom field values for the order, keyed by field code.


        The format of each value depends on the field's input type:

        - **select**: `{"id": <integer>, "label": "<string>"}`

        - **multiselect**: `[{"id": <integer>, "label": "<string>"}, ...]`

        - **currency**: Uses the Monetary type `{"amount": <number>, "currency":
        "<string>"}`

        - **boolean**: `{"value": <boolean>}`

        - **text/multiline-text/email/url/date**: `{"value": "<string>"}`

        - **number**: `{"value": <number>}`

        - **admin-user/client-user**: `{"value": <integer>}` (user ID)
      additionalProperties:
        $ref: '#/components/schemas/System_API_v1_custom_field_value'
      example:
        is_gift:
          value: true
        order_details:
          value: test details
        department:
          id: 3
          label: Shipping
        priority_levels:
          - id: 1
            label: Urgent
          - id: 2
            label: High
        cost_of_goods:
          amount: 156.99
          currency: USD
        assigned_user:
          value: 42
    System_API_v1_UserRoleRef:
      title: UserRoleRef
      type: object
      description: Reference a `UserRole` by `id`.
      properties:
        type:
          type: string
          enum:
            - OrganizationUserRole
            - ClientUserRole
        id:
          type: integer
          format: int32
          example: 3
          description: >-
            The internal `id` property used as a path parameter in a resource
            lookup.
      required:
        - type
        - id
      additionalProperties: false
    System_API_v1_custom_field_value:
      description: Union type for all possible custom field value formats.
      anyOf:
        - $ref: '#/components/schemas/System_API_v1_custom_field_scalar_value'
        - $ref: '#/components/schemas/System_API_v1_Monetary'
        - $ref: '#/components/schemas/System_API_v1_custom_field_select_option'
        - $ref: '#/components/schemas/System_API_v1_custom_field_multiselect_value'
    System_API_v1_custom_field_scalar_value:
      type: object
      description: |-
        A wrapper for scalar custom field values.
        The value type depends on the field's input type:
        - **boolean**: boolean value
        - **text/multiline-text/email/url/date**: string value
        - **number**: number value
        - **admin-user/client-user**: integer value (user ID)
      required:
        - value
      properties:
        value:
          description: The field value. Type varies based on field configuration.
          oneOf:
            - type: boolean
            - type: string
            - type: number
            - type: integer
      additionalProperties: false
    System_API_v1_Monetary:
      title: Monetary
      type: object
      nullable: true
      properties:
        amount:
          type: number
          description: This is the monetary value..
          format: float
          example: 99
        currency:
          type: string
          description: An ISO 3166-1 alpha-3 currency code.
          example: USD
    System_API_v1_custom_field_select_option:
      type: object
      description: A selected option for select type fields.
      required:
        - id
        - label
      properties:
        id:
          type: integer
          description: The option ID.
        label:
          type: string
          description: The display label for the selected option.
      additionalProperties: false
    System_API_v1_custom_field_multiselect_value:
      type: array
      description: Array of selected options for multiselect type fields.
      items:
        $ref: '#/components/schemas/System_API_v1_custom_field_select_option'
  responses:
    System_API_v1_400-bad-request:
      description: >-
        The request was invalid. The client must change the request. See the
        response body for more details.
      content:
        application/json:
          schema:
            type: object
            properties:
              errors:
                type: array
                items:
                  type: object
                  properties:
                    type:
                      type: string
                      description: The error type code.
                      enum:
                        - parser
                        - parameters
                        - openapi
                    message:
                      type: string
                      description: An English sentence describing the error type.
                    details:
                      type: array
                      description: >-
                        An array of objects describing which keys are
                        responsible for the error and detailed messages
                        describing why they are not valid.
                      items:
                        type: object
                        properties:
                          key:
                            type: string
                            description: The path to the key which relates to the error.
                          message:
                            type: string
                            description: >-
                              An English sentence describing the details of the
                              error.
                        additionalProperties: false
                  additionalProperties: false
                minItems: 1
            additionalProperties: false
          example:
            errors:
              - type: parameters
                message: The supplied parameters are invalid.
                details:
                  - key: hold_until_date
                    message: The date must be in the future.
    System_API_v1_404-not-found:
      description: >-
        The requested resource was not found. It may have been deleted, it may
        have never existed, or you may not have permission to view it.
      content:
        application/json:
          schema:
            type: object
            properties:
              errors:
                type: array
                items:
                  type: object
                  properties:
                    type:
                      type: string
                      description: The error type code.
                      enum:
                        - not_found
                    message:
                      type: string
                      description: An English sentence describing the error type.
                    details:
                      type: array
                      description: >-
                        An array of objects describing which keys are
                        responsible for the error and detailed messages
                        describing why they are not valid.
                      items:
                        type: object
                        properties:
                          key:
                            type: string
                            description: The path to the key which relates to the error.
                          message:
                            type: string
                            description: >-
                              An English sentence describing the details of the
                              error.
                        additionalProperties: false
                  additionalProperties: false
                minItems: 1
            additionalProperties: false
          example:
            errors:
              - type: not_found
                message: The server could not find the requested resource.
    System_API_v1_500-internal-server-error:
      description: >-
        Internal Server Error - Something wrong happened at server side. Contact
        server administrator for more details.
  securitySchemes:
    ShipStream_bearerAuth:
      type: http
      scheme: bearer
      bearerFormat: JWT
      description: >-
        Generate a JWT access token through a Custom Global Integration and
        provide it with each request in the `Authorization` header prefixed with
        "Bearer" and then a single space.

````